Geodesic
Date: 2019-10-22

org.jmol.util

## Class Geodesic

- java.lang.Object
- - org.jmol.util.Geodesic

-     public class Geodesic
      extends java.lang.Object

  J2SRequireImport is needed because we use ArrayUtil in a static method

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static int` | `currentLevel`
    `private static short[][]` | `faceVertexesArrays`
    `private static short[]` | `faceVertexesIcosahedron`
    `private static float` | `halfRoot5`
    `private static java.util.Map<java.lang.Integer,java.lang.Short>` | `htVertex`
    `private static int` | `maxLevel`
    `private static short[][]` | `neighborVertexesArrays`
    `private static short[]` | `neighborVertexesIcosahedron`
    `private static float` | `oneFifth`
    `private static float` | `oneTenth`
    `static int` | `standardLevel` 3 levels, 0 through 3
    `private static boolean` | `VALIDATE`
    `private static short[]` | `vertexCounts`
    `private static short` | `vertexNext`
    `private static javajs.util.V3[]` | `vertexVectors`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Geodesic()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private static void` | `addNeighboringVertexes(short[] neighborVertexes, short v1, short v2)`
    `static void` | `createGeodesic(int lvl)`
    `static short[]` | `getFaceVertexes(int level)`
    `static short[][]` | `getNeighborVertexesArrays()`
    `private static short` | `getVertex(short v1, short v2)`
    `static short` | `getVertexCount(int level)`
    `static javajs.util.V3` | `getVertexVector(int i)`
    `static javajs.util.V3[]` | `getVertexVectors()`
    `private static void` | `quadruple(int level, short[] counts)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### halfRoot5

          private static final float halfRoot5

    - #### oneFifth

          private static final float oneFifth

      See Also:
        Constant Field Values

    - #### oneTenth

          private static final float oneTenth

      See Also:
        Constant Field Values

    - #### faceVertexesIcosahedron

          private static final short[] faceVertexesIcosahedron

    - #### neighborVertexesIcosahedron

          private static final short[] neighborVertexesIcosahedron

    - #### standardLevel

          public static final int standardLevel

      3 levels, 0 through 3
      See Also:
        Constant Field Values

    - #### maxLevel

          private static final int maxLevel

      See Also:
        Constant Field Values

    - #### vertexCounts

          private static short[] vertexCounts

    - #### vertexVectors

          private static javajs.util.V3[] vertexVectors

    - #### faceVertexesArrays

          private static short[][] faceVertexesArrays

    - #### neighborVertexesArrays

          private static short[][] neighborVertexesArrays

    - #### currentLevel

          private static int currentLevel

    - #### vertexNext

          private static short vertexNext

    - #### htVertex

          private static java.util.Map<java.lang.Integer,java.lang.Short> htVertex

    - #### VALIDATE

          private static final boolean VALIDATE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Geodesic

          public Geodesic()

  - ### Method Detail

    - #### getNeighborVertexesArrays

          public static short[][] getNeighborVertexesArrays()

    - #### getVertexCount

          public static short getVertexCount(int level)

    - #### getVertexVectors

          public static javajs.util.V3[] getVertexVectors()

    - #### getVertexVector

          public static javajs.util.V3 getVertexVector(int i)

    - #### getFaceVertexes

          public static short[] getFaceVertexes(int level)

    - #### createGeodesic

          public static void createGeodesic(int lvl)

    - #### quadruple

          private static void quadruple(int level,
                                        short[] counts)

    - #### addNeighboringVertexes

          private static void addNeighboringVertexes(short[] neighborVertexes,
                                                     short v1,
                                                     short v2)

    - #### getVertex

          private static short getVertex(short v1,
                                         short v2)